/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>

#define MAXSLP	32

int
myconnect(int fd, struct sockaddr *addrp, int alen)
{
	int i;

	/*
	 * Try several times to connect.
	 */
	for (i = 1; i <= MAXSLP; i <<= 1) {
		if (connect(fd, addrp, alen) == 0)
			/*
			 * Connection accepted.
			 */
			return(0);

		/*
		 * Delay before trying again.
		 */
		sleep(i);
	}

	/*
	 * We reached the maximum retry count.  Print
	 * an error message, set the global error code,
	 * and return -1.
	 */
	fprintf(stderr, "Connect timed out\n");
	errno = ETIME;
	return(-1);
}
